function y = goldbeter_fnc(u)
% This block supports the Embedded MATLAB subset.
% See the help menu for details. 
% Parameter for the Goldbeter model

be=u(3);
v0=1;       % [uM/s]
k=10;       % [1/s]
kf=1;       % [1/s]
v1=7.3;     % [uM/s]
V_M2=65;    % [uM/s]
V_M3=500;   % [uM/s]
K2=1;       % [uM]
K_R=2;      % [uM]
K_A=0.9;    % [uM]
m=2;
n=2;
p=4;

y(1) = v0+v1*be-V_M2*u(1)^n/(K2^n+u(1)^n)+V_M3*u(2)^m/(K_R^m+u(2)^m)*u(1)^p/(K_A^p+u(1)^p)+kf*u(2)-k*u(1);
y(2) = V_M2*u(1)^n/(K2^n+u(1)^n)-V_M3*u(2)^m/(K_R^m+u(2)^m)*u(1)^p/(K_A^p+u(1)^p)-kf*u(2);